// MySaxParser.java

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class MySAXParser extends DefaultHandler
{
  private Params params;
  private StringBuffer buf = new StringBuffer();
  private Vector data = new Vector();

  public Object[][] processURL(URL url) throws Exception
  {
    InputSource inputSource =
      new InputSource(url.openStream());
    SAXParserFactory fact = SAXParserFactory.newInstance();
    SAXParser parser = fact.newSAXParser();
    parser.parse(inputSource, this); // Execute parsing
    int nbRecords = data.size();
    int nbItems = 10;
    Object[][] collection = new Object[nbRecords][nbItems];
    for (int i = 0; i < nbRecords; i++)
      for (int k = 0; k < nbItems; k++)
        collection[i][k] = ((Params)data.get(i)).getInfo(k);
    return collection;
  }

  // ------------- Callback methods ------------------
  public void startElement(String uri, String localName,
                           String qname,
                           Attributes attributes)
  {
    buf.setLength(0);
    if (qname.equals("params"))
      params = new Params();
  }

  public void endElement(String uri, String localName,
                         String qname)
  {
    if (qname.equals("opacity"))
    {
      params.setInfo(0, checkInt(qname, buf.toString()));
      return;
    }
    if (qname.equals("color"))
    {
      params.setInfo(1, buf.toString());
      return;
    }
    if (qname.equals("xstart"))
    {
      params.setInfo(2, checkInt(qname, buf.toString()));
      return;
    }
    if (qname.equals("ystart"))
    {
      params.setInfo(3, checkInt(qname, buf.toString()));
      return;
    }
    if (qname.equals("border"))
    {
      params.setInfo(4, checkInt(qname, buf.toString()));
      return;
    }
    if (qname.equals("xhome"))
    {
      params.setInfo(5, checkInt(qname, buf.toString()));
      return;
    }
    if (qname.equals("yhome"))
    {
      params.setInfo(6, checkInt(qname, buf.toString()));
      return;
    }
    if (qname.equals("activetitle"))
    {
      params.setInfo(7, buf.toString());
      return;
    }
    if (qname.equals("logo"))
    {
      if (buf.toString().equals("true"))
        params.setInfo(8, true);
      else
        params.setInfo(8, false);
      return;
    }
    if (qname.equals("enumwindows"))
    {
      if (buf.toString().equals("true"))
        params.setInfo(9, true);
      else
        params.setInfo(9, false);
      return;
    }
    if (qname.equals("params"))
    {
      data.add(params);
    }
  }

  public void characters(char[] chars, int start, int length)
  {
    buf.append(chars, start, length);
  }

  private Integer checkInt(String name, String valueStr)
  {
    Integer value = null;
    try
    {
      value = Integer.valueOf(valueStr);
    }
    catch (NumberFormatException ex)
    {
      JOptionPane.showMessageDialog(
         null,
         "Illegal value of \"" + name + "\" detected in file \"coversheet.xml\"",
         "Fatal Error",
         JOptionPane.INFORMATION_MESSAGE);
      System.exit(0);
    }
    return value;
  }


}
