// TextWindow.java

import javax.swing.*;
import javax.swing.text.*;

public class TextWindow extends JFrame
{
  private JPanel contentPane;
  private JTextArea jTextArea = new JTextArea(30, 50);
  private JScrollPane jScrollPane =
              new JScrollPane(jTextArea,
                              JScrollPane.
                              VERTICAL_SCROLLBAR_AS_NEEDED,
                              JScrollPane.
                              HORIZONTAL_SCROLLBAR_AS_NEEDED);

  public TextWindow(String title, String text)
  {
    super(title);
    setDefaultCloseOperation(WindowConstants.
                             DISPOSE_ON_CLOSE);
    contentPane = (JPanel)getContentPane();
    contentPane.add(jScrollPane);
    pack();
    jTextArea.append(text);
    scrollToEnd();
    setVisible(true);
  }


  private void scrollToEnd()
  {
    try
    {
      jTextArea.setCaretPosition(
          jTextArea.getLineEndOffset(
              jTextArea.getLineCount()-1));
    }
    catch (BadLocationException ex)
    {
      System.out.println(ex);
    }
  }

  public static void main(String[] args)
  {
    new TextWindow("Test", "1. Line\n2.Linie");
  }
}
